//First step check parameters mismatch and checking network connection if available call download function

function DownloadFile(URL, Folder_Name, File_Name) {
    if (device.platform == 'android' || device.platform == 'Android' || device.platform == 'amazon-fireos') {
        //Parameters mismatch check
        if (URL == null && Folder_Name == null && File_Name == null) {
            return;
        } else {
            download(URL, Folder_Name, File_Name); //If available download function call
        }
    } else {
        cordova.plugins.imgDownloader.downloadWithUrl(URL,function(){
            navigator.notification.alert("La Photo a bien été enregistrée !", alertCallback, "Téléchargement Réussi", "Ok");
        },function(){
            navigator.notification.alert("Votre connexion est mauvaise. Votre Photo n'a pas pu être enregistrée...", alertCallback, "Connexion Mauvaise", "Ok");
        });
    }
}

function download(URL, Folder_Name, File_Name) {
//step to request a file system 
    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, fileSystemSuccess, fileSystemFail);

function fileSystemSuccess(fileSystem) {
    var download_link = encodeURI(URL);
    ext = download_link.substr(download_link.lastIndexOf('.') + 1); //Get extension of URL

    var directoryEntry = fileSystem.root; // to get root path of directory
    directoryEntry.getDirectory(Folder_Name, { create: true, exclusive: false }, onDirectorySuccess, onDirectoryFail); // creating folder in sdcard
    var rootdir = fileSystem.root;
	var fp = rootdir.toURL(); // Returns Fulpath of local directory

    fp = fp + "/Pictures/" + Folder_Name + "/" + File_Name + "." + ext; // fullpath and name of the file which we want to give
    // download function call
    filetransfer(download_link, fp);
}

function onDirectorySuccess(parent) {
    // Directory created successfuly
}

function onDirectoryFail(error) {
    //Error while creating directory
    alert("Unable to create new directory: " + error.code);
}

  function fileSystemFail(evt) {
    //Unable to access file system
    alert(evt.target.error.code);
 }
}

function filetransfer(download_link, fp) {
var fileTransfer = new FileTransfer();
// File download function with URL and local path
fileTransfer.download(download_link, fp,
                    function (entry) {
						navigator.notification.alert("La Photo a bien été enregistrée !", alertCallback, "Téléchargement Réussi", "Ok");
                        //alert("download complete: " + entry.fullPath);
                    },
                 function (error) {
                     //Download abort errors or download failed errors
					 navigator.notification.alert("Votre connexion est mauvaise. Votre Photo n'a pas pu être enregistrée...", alertCallback, "Connexion Mauvaise", "Ok");
                     //alert("download error source " + error.source);
                     //alert("download error target " + error.target);
                     //alert("upload error code" + error.code);
                 }
            );
}

/* PICTURES */

function capitaliseFirstLetter(string) {
    return string.charAt(0).toUpperCase() + string.slice(1);
}

if (typeof String.prototype.startsWith != 'function') {
	String.prototype.startsWith = function (str){
		return this.slice(0, str.length) == str;
	};
}

if (typeof String.prototype.endsWith != 'function') {
	String.prototype.endsWith = function (str){
		return this.slice(-str.length) == str;
	};
}

$( "#_picture" ).click(function() {
if (device.platform == 'android' || device.platform == 'Android' || device.platform == 'amazon-fireos') {
	navigator.camera.getPicture(onSuccess, onFail, { quality: window.localStorage.getItem( 'quality' ), // 0 to 100
		destinationType: Camera.DestinationType.FILE_URI,
		//sourceType: navigator.camera.PictureSourceType.PHOTOLIBRARY,
		correctOrientation: 1,
		encodingType: Camera.EncodingType.JPEG
	});
} else {
	navigator.camera.getPicture(onSuccess, onFail, { quality: window.localStorage.getItem( 'quality' ), // 0 to 100
		destinationType: Camera.DestinationType.FILE_URI,
		//sourceType: navigator.camera.PictureSourceType.PHOTOLIBRARY,
		correctOrientation: 1,
		encodingType: Camera.EncodingType.JPEG
	});
}
});

$( "#_pictureSaved" ).click(function() {
if (device.platform == 'android' || device.platform == 'Android' || device.platform == 'amazon-fireos') {
	navigator.camera.getPicture(onSuccess, onFail, { quality: window.localStorage.getItem( 'quality' ), // 0 to 100
		destinationType: Camera.DestinationType.FILE_URI,
		sourceType: navigator.camera.PictureSourceType.PHOTOLIBRARY,
		correctOrientation: 1,
		encodingType: Camera.EncodingType.JPEG
	});
} else {
	navigator.camera.getPicture(onSuccess, onFail, { quality: window.localStorage.getItem( 'quality' ), // 0 to 100
		destinationType: Camera.DestinationType.FILE_URI,
		sourceType: navigator.camera.PictureSourceType.PHOTOLIBRARY,
		correctOrientation: 1,
		encodingType: Camera.EncodingType.JPEG
	});
}
});

function sendPicture (imageURI, randomID) {

	window.localStorage.setItem( 'randomID', randomID);
	var options = new FileUploadOptions();
	options.fileKey="file";
	options.fileName=imageURI.substr(imageURI.lastIndexOf('/')+1)+'.jpg';
	//options.mimeType="image/jpeg";
	options.mimeType="text/plain";

	var params = new Object();
	params.value1 = randomID;

	options.params = params;
	options.chunkedMode = false;

	var ft = new FileTransfer();
	ft.upload(imageURI, "http://popcluster.eu/up/upload.php", win, fail, options);
}

function onSuccess(imageURI) {
	var randomID = randString(7);
	$( ".outputMessages" ).prepend( '<div id="_'+ randomID +'"><div id="_button'+ randomID +'" class="message insideMessages messageOnRight"><img id="_navigator'+ randomID +'" class="filter" width="100px" src="'+ imageURI +'"></div><div class="insideMessages messageOnRight date">' + displayTime() + '</div></div>' );
	$( '#_button'+ randomID +'' ).append( '<div class="formatButton"><button id="_buttonErase'+ randomID +'" type="button" class="btn btn-danger btn-sm"><span class="glyphicon glyphicon-trash" aria-hidden="true"></span>&nbsp;&nbsp;<b>Supprimer</b></button><br><button id="_buttonSend'+ randomID +'" type="button" class="btn btn-success btn-sm buttonSend"><span class="glyphicon glyphicon-send" aria-hidden="true"></span>&nbsp;&nbsp;<b>Envoyer</b></button></div>' );
	$( '#_buttonErase'+ randomID +'' ).click(function() {
		$( '#_'+ randomID +'' ).remove();
	});
	$( '#_buttonSend'+ randomID +'' ).click(function() {
		$( '#_buttonErase'+ randomID +'' ).remove();
		$( '#_buttonSend'+ randomID +'' ).remove();
		$( '#_button'+ randomID +'' ).append( '&nbsp;&nbsp;<img class="loaderPicture" src="img/loader.gif">');
		sendPicture(imageURI, randomID);
		showDateDoubleTap(randomID);
	});
}

function onFail(message) {
    //alert('Failed because: ' + message);
}

function win(r) {
	//console.log("Code = " + r.responseCode);
	//console.log("Response = " + r.response);
	//console.log("Sent = " + r.bytesSent);
	var globalResponse = r.response.split("_");
	var leftResponse = globalResponse[0];	
	var rightResponse = globalResponse[1];	
	if (leftResponse == "failCode") {
		navigator.notification.alert("La taille de votre photo est trop importante.", alertCallback, "Photo", "Ok");
		$( '#_'+ rightResponse +'' ).remove();
		$( '.loaderPicture' ).hide();
	} else {
		var urlToSend = r.response;
		//$('#_navigator'+ window.localStorage.getItem( 'randomID' ) +'').attr("src", urlToSend);
		var rrr = window.localStorage.getItem( 'randomID' );
		sendPictureUrl(urlToSend, rrr);
	}
}

function fail(error) {
	alert("An error has occurred: Code = " + error.code);
}

function sendPictureUrl(urlToSend, rrr) {
	var formData = {
		'name'				: window.localStorage.getItem( 'currentSendClusterMin' ),
		'notif'				: urlToSend,
		'deviceid'			: window.localStorage.getItem( 'device' ),
		'olddeviceid'		: window.localStorage.getItem( 'olddevice' ),
		'uuid'				: window.localStorage.getItem( 'uuid' ),
		'olduuid'			: window.localStorage.getItem( 'olduuid' ),
		'devicePlatform'	: window.localStorage.getItem( 'devicePlatform' )
	};

	var ajaxPictures = null;

	var timerPictures  = setTimeout(function(){
		if (ajaxPictures != null) {
			ajaxPictures.abort();
		}
	},10000);
			
	ajaxPictures = $.ajax({
						type: 'POST',
						url: getServer() +'v1-4/send.php',
						data: formData,
						dataType: 'json',
						encode: true
					});
					ajaxPictures.done(function(dataSend) {
						//alert("URL ENVOYEE");
						$( '.loaderPicture' ).hide();
						clearTimeout(timerPictures);
						$( '#_navigator'+ rrr +'' ).click(function() {
							if ( urlToSend.startsWith("http://popcluster.eu/up/thumbs/") ) {
								var imagePoorQuality = urlToSend.replace("http://popcluster.eu/up/thumbs/", "http://popcluster.eu/up/uploads/");
							} else {
								var imagePoorQuality = urlToSend.replace("http://popcluster.eu/up/thumbs-logo/", "http://popcluster.eu/up/uploads-logo/");
							}
							var pictureResizedFromPhp = "http://popcluster.eu/up/resize.php?picture=" + imagePoorQuality;
							window.open(pictureResizedFromPhp, '_blank', 'location=no');
						});
					});
					ajaxPictures.fail(function(dataSend) {
						//alert("URL à supprimer");
						clearTimeout(timerPictures);
						retrieveServer();
					});
}


/* INITIALIZATION AND OTHERS */

var pushNotification;

getServer();

document.addEventListener('deviceready', onDeviceReady, true);

function alertCallback() {
    return;
}

function displayTime() {
	var date = new Date();
	var year = date.getFullYear();
	var month = ( '0' + (date.getMonth()+1) ).slice( -2 );
	var day = ( '0' + (date.getDate()) ).slice( -2 );
	var hour = ( '0' + (date.getHours()) ).slice( -2 );
	var minute = ( '0' + (date.getMinutes()) ).slice( -2 );
	var second = ( '0' + (date.getSeconds()) ).slice( -2 );
	var outputDate = year + '-' + month + '-' + day + ' ' + hour + ':' + minute + ':' + second;
	return outputDate;
}

function refreshing() {
	if (device.platform == 'android' || device.platform == 'Android' || device.platform == 'amazon-fireos') {
		navigator.app.loadUrl('file:///android_asset/www/index.html');
	} else {
		location.reload(true);
	}
}

function getServer() {
	var srv = window.localStorage.getItem( 'serverBaseUrl' );
	if(srv===null) {
		retrieveServer();
	}
	return window.localStorage.getItem( 'serverBaseUrl' );
}

function retrieveServer() {
	$.ajax({
		type: 'GET',
		url: 'http://popcluster.eu/server.txt'
	})
	.done(function(data) {
		window.localStorage.setItem( 'serverBaseUrl', data);
	})
	.fail(function(data) {
		window.localStorage.setItem( 'serverBaseUrl', "http://popcluster.eu/");
	});
}

function handleOpenURL(url) {

  setTimeout(function() {
		var prot = url.split("?");
		var params = prot[1].split("&");
		var grparam = params[0].split("=");
		var psparam = params[1].split("=");
		var group = grparam[1];
		var passw = psparam[1];
		
		/* ENVOI DES DONNEES RECUPEREES PAR LE LIEN */
		
		navigator.notification.confirm(
		"Êtes-vous sûr de vouloir ajouter cet événement ?", // message
		onConfirm, // callback to invoke with index of button pressed
		"Confirmation", // title
		"Oui,Non" // buttonLabels
		);

		function onConfirm(buttonIndex) {
			if (buttonIndex != 1) {
				navigator.notification.alert("Ok, cet n'est probablement pas pour vous !", alertCallback, "Annulation", "Ok");
			} else {

		var formData = {
            'name': group,
            'secret': passw,
            'deviceid'			: window.localStorage.getItem( 'device' ),
			'olddeviceid'		: window.localStorage.getItem( 'olddevice' ),
			'uuid'				: window.localStorage.getItem( 'uuid' ),
			'olduuid'			: window.localStorage.getItem( 'olduuid' ),
            'devicePlatform'	: window.localStorage.getItem( 'devicePlatform' )
        };

        // process the form
        $.ajax({
                type: 'POST', // define the type of HTTP verb we want to use (POST for our form)
                url: getServer() +'v1-4/add.php', // the url where we want to POST
                data: formData, // our data object
                dataType: 'json', // what type of data do we expect back from the server
                encode: true
            })
            // using the done promise callback
            .done(function(dataAdd) {
				
				navigator.notification.alert("Vous êtes maintenant membre du Cluster !", alertCallback, "Succès", "Ok");
				refreshing();
            })

        // using the fail promise callback
        .fail(function(dataAdd) {
		
			navigator.notification.alert("Ok, ce Cluster n'est probablement pas pour vous !", alertCallback, "Annulation", "Ok");
			retrieveServer();
        });

		}
		}
		
		/* FIN ENVOI DES DONNEES RECUPEREES PAR LE LIEN  */
		
  }, 0);
}

function showError() {
	if (device.platform == 'android' || device.platform == 'Android' || device.platform == 'amazon-fireos') {
		$('#_timeoutANDROID').show();
		$('#_timeoutANDROID').css('display', 'table');
		$('#_imgReloadANDROID').click(function() {
			refreshing();
		});
	} else {
		$('#_timeoutIOS').show();
		$('#_timeoutIOS').css('display', 'table');
		$('#_imgReloadIOS').click(function() {
			refreshing();
		});
	}
}


/*  */
/*  */
/* ADD FUNCTION */
/*  */
/*  */


function callServerAdd() {

$('.return').click(function() {
	$('.dad').show();
	$('#_result').show();
	$('#_titleAdd').hide();
	$('.title').css('position', 'fixed');
	$('.addRedirect').css('position', 'fixed');
	$('#_titleListing').show();
	$('.addRedirect').show();
	$('.addRedirectStart').show();
	$('#_formadd').hide();
	$('.return').hide();
	$('.no-cluster').show();
	window.localStorage.setItem( 'currentScreen' , 'listing');
});


$("#_nameAdd").on('blur',function(){
	$('.divScrollable').css('margin-bottom', '100%');
	window.scrollTo(0,0);
	$('.divScrollable').css('margin-bottom', '0');
	$('body').off('touchmove');
});

$("#_secretAdd").on('blur',function(){
	$('.divScrollable').css('margin-bottom', '100%');
	window.scrollTo(0,0);
	$('.divScrollable').css('margin-bottom', '0');
	$('body').off('touchmove');
});

$("#_nameAdd").on('focus',function(){
	$('body').on('touchmove', function(evt) {
		evt.preventDefault();
	});
});

$("#_secretAdd").on('focus',function(){
	$('body').on('touchmove', function(evt) {
		evt.preventDefault();
	});
});

$('#_qrcodeLaunch').click(function() {
	cordova.plugins.barcodeScanner.scan(
		function (result) {
			if ( result.text.startsWith("http:\/\/popcluster.eu\/p.php?c=") ) {
				var urlQR = result.text.split("?c=");
				var urlQR = result.text.split("?c=");
				var urlQR = "http://popcluster.eu/p.php?c="+urlQR[1];
				handleOpenURL(urlQR);
			} else {
				navigator.notification.alert("Votre QR Code est illisible. Essayez encore !", alertCallback, "QR Code", "Ok");
			}
		}, 
		function (error) {
			navigator.notification.alert("Votre QR Code est illisible. Essayez encore !", alertCallback, "QR Code", "Ok");
		}
	);
});

    $('#_formadd').submit(function(event) {
		
		$('#_submitAdd').hide();
		$('#_loaderAdd').show();
        $('.yellow-notif').remove();
		$('#_name-groupAdd').removeClass("has-error");
		$('#_secret-groupAdd').removeClass("has-error");

        var formData = {
            'name': $('input[name=nameAdd]').val(),
            'secret': $('input[name=secretAdd]').val(),
            'deviceid'			: window.localStorage.getItem( 'device' ),
			'olddeviceid'		: window.localStorage.getItem( 'olddevice' ),
			'uuid'				: window.localStorage.getItem( 'uuid' ),
			'olduuid'			: window.localStorage.getItem( 'olduuid' ),
            'devicePlatform'	: window.localStorage.getItem( 'devicePlatform' )
        };

var ajaxAdd = null;

var timerAdd = setTimeout(function(){
	if (ajaxAdd != null) {
		ajaxAdd.abort();
	}
},10000);

ajaxAdd = $.ajax({
                type: 'POST',
                url: getServer() +'v1-4/add.php',
                data: formData,
                dataType: 'json',
                encode: true
            });
            ajaxAdd.done(function(dataAdd) {

                if (!dataAdd.success) {

                    if (dataAdd.errors.name) {
						$('#_name-groupAdd').addClass("has-error");
                        $('#_name-groupAdd').append('<div class="yellow-notif">Le Nom de l\'événement est requis.</div>');
                    }

                    if (dataAdd.errors.secret) {
						$('#_secret-groupAdd').addClass("has-error");
                        $('#_secret-groupAdd').append('<div class="yellow-notif">Un Mot de Passe est requis.</div>');
                    }

                } else {
				
				var errorCodeAdd;
				switch (dataAdd.message) {
					case "code4":
						errorCodeAdd = "Vous êtes maintenant un membre de ce Cluster.";
						break;
					case "code5":
						errorCodeAdd = "Ce Cluster n'existe pas.";
						break;
					case "code6":
						errorCodeAdd = "Votre code est incorrect.";
						break;
				}

                    if (dataAdd.already == "1") {
						navigator.notification.alert(errorCodeAdd, refreshing(), "Succès", "Ok");
                    } else {
						navigator.notification.alert(errorCodeAdd, alertCallback, "Échec", "Ok");
                    }
                }
				clearTimeout(timerAdd);
				$('#_loaderAdd').hide();
				$('#_submitAdd').show();
            });

        ajaxAdd.fail(function(dataAdd) {
			clearTimeout(timerAdd);
			showError();
			$('#_loaderAdd').hide();
			$('#_submitAdd').show();
			retrieveServer();
        });
        event.preventDefault();
    });

}


function addRedirect() {

$('.addRedirect, .addRedirectStart').click(function() {
	$('.dad').hide();
	$('#_result').hide();
	$('#_titleListing').hide();
	$('.title').css('position', 'absolute');
	$('.return').css('position', 'absolute');
	$('#_titleAdd').show();
	$('.addRedirect').hide();
	$('.addRedirectStart').hide();
	$('.return').show();
	$('.no-cluster').hide();
		
	analytics.startTrackerWithId('UA-53293565-1');
	analytics.trackView('Add');
	window.localStorage.setItem( 'currentScreen' , 'add');
	
	$('#_endTutorialAdd2').append("Ok");
	$('#_joinCluster').append("Rejoindre un Cluster");
	$('#_senderAdd').attr("src", "img/add-submit-fr.png");
	
	$('#_formadd').show();
	if ($('.existsAdd').length) {
		return;
	} else {
		$('#_result').append('<div class="existsAdd"></div>');
		callServerAdd();
	}
});

}


$('#_generateCode').click(function() {
	var randomCode = randString(7);
	$("#_secret").val(randomCode);
	$("#_secret").attr("value", randomCode);
});

$('#_owner').change(function(){
	if ($('#_owner').is(':checked') == false){
		navigator.notification.alert( "En décochant cette case, vous serez le seul à pouvoir envoyer des Pops à ce Cluster !", alertCallback, "Soyez prudent", "Ok");
	}
});


function randString(n) {
    if (!n) {
        n = 7;
    }

    var text = '';
    var possible = 'abcdefghijklmnopqrstuvwxyz0123456789';

    for (var i = 0; i < n; i++) {
        text += possible.charAt(Math.floor(Math.random() * possible.length));
    }

    return text;
}






/*  */
/*  */
/* LISTING FUNCTION */
/*  */
/*  */

function onDeviceReady() {

$('#_imgTuto').attr("src", "img/tuto-fr.png");
$('#_imgReloadIOS').attr("src", "img/reload-fr.png");
$('#_imgReloadANDROID').attr("src", "img/reload-fr.png");
$('.addRedirect').attr("src", "img/add-fr.png");
$('.return').attr("src", "img/return-fr.png");
$('.inviteRedirect').attr("src", "img/invite-fr.png");
$('#_networkIOS1').append("Votre <span class=\"red\">connexion</span> semble problématique... Merci de vérifier votre connexion.");
$('#_networkIOS2').append("ou");
$('#_networkIOS3').append("Make sure your <span class=\"red\">notifications</span> are enabled. Activate them in : ");
$('#_networkIOS4').append("Réglages > Centre de Notifications > PopCluster");
$('#_networkANDROID').append("Votre <span class=\"red\">connexion</span> semble problématique... Merci de vérifier votre connexion.");
$('#_name').attr("placeholder", "Nom du nouveau groupe");
$('#_secret').attr("placeholder", "Code de votre groupe");
$('#_widthCluster').append("ÉVÉNEMENT");
$('#_widthCode').append("CODE");
$('#_ownerTxt').append("Tout le monde peut envoyer des Messages.");
$('#_nameAdd').attr("placeholder", "Événement de votre Ami");
$('#_secretAdd').attr("placeholder", "Mot de Passe Événement");
$('#_widthClusterAdd').append("ÉVÉNEMENT");
$('#_widthCodeAdd').append("CODE");
$('#_titleAdd').html("Rejoindre");
$('#_titleInvite').html("Inviter");

$(function() {
    FastClick.attach(document.body);
});

if (device.platform == 'android' || device.platform == 'Android' || device.platform == 'amazon-fireos') {
	window.localStorage.setItem( 'devicePlatform', "0");
} else {
	window.localStorage.setItem( 'devicePlatform', "1");
}

if ( ( window.localStorage.getItem( 'uuid' ) ) != ( device.uuid ) ) {

	if ( ( window.localStorage.getItem( 'uuid' ) ) == null ) {
		// le code n'a jamais été enregistré car c'est la premiere utilisation, on doit alors l'enregistrer pour la première fois
		window.localStorage.setItem( 'uuid', device.uuid);
		window.localStorage.setItem( 'olduuid', '');
	} else {
		// le code est différent de celui qui est enregistré, il a donc changé, on doit changer le nouveau code
		window.localStorage.setItem( 'olduuid', window.localStorage.getItem( 'uuid' ));
		window.localStorage.setItem( 'uuid', device.uuid);
	}
	
} else {
	window.localStorage.setItem( 'uuid', device.uuid);
	window.localStorage.setItem( 'olduuid', '');
}

callServerIndex();

if ( ( window.localStorage.getItem( 'slides' ) ) == null ) {

	$('#_slides').show();
	$('.hideAllItems').hide();
	$('.dad').hide();

	$('#_endTutorialSlides').click(function() {
/* 		$('#_slides').hide();
		$('.hideAllItems').show();
		$('.dad').show(); */
		window.localStorage.setItem( 'slides', '1');
		refreshing();
	});

}

$('#_loader').show();

	analytics.startTrackerWithId('UA-53293565-1');
	analytics.trackView('Listing');
	window.localStorage.setItem( 'currentScreen' , 'listing');
	
    document.addEventListener("backbutton", function(e) {

        if ($("#_home").length > 0) {
            // call this to get a new token each time. don't call it to reuse existing token.
            //pushNotification.unregister(successHandler, errorHandler);
            e.preventDefault();
            navigator.app.exitApp();
        } else {
            navigator.app.backHistory();
        }
    }, false);

    try {
        pushNotification = window.plugins.pushNotification;

        if (device.platform == 'android' || device.platform == 'Android' || device.platform == 'amazon-fireos') {
            pushNotification.register(successHandler, errorHandler, {
                "senderID": "407567074050",
                "ecb": "onNotification"
            }); // required!
        } else {
            pushNotification.register(tokenHandler, errorHandler, {
                "badge": "true",
                "sound": "true",
                "alert": "true",
                "ecb": "onNotificationAPN"
            }); // required!
        }
    } catch (err) {
        txt = "There was an error on this page.\n\n";
        txt += "Error description: " + err.message + "\n\n";
        alert(txt);
    }
}


function callServerIndex() {

        // get the form data
        // there are many ways to get this data using jQuery (you can use the class or id also)
        var formData = {
            'deviceid'			: window.localStorage.getItem( 'device' ),
			'olddeviceid'		: window.localStorage.getItem( 'olddevice' ),
			'uuid'				: window.localStorage.getItem( 'uuid' ),
			'olduuid'			: window.localStorage.getItem( 'olduuid' ),
            'devicePlatform'	: window.localStorage.getItem( 'devicePlatform' )
        };

var ajaxIndex = null;

var timerIndex = setTimeout(function(){
	if (ajaxIndex != null) {
		ajaxIndex.abort();
	}
},10000);

ajaxIndex = $.ajax({
                type: 'POST', // define the type of HTTP verb we want to use (POST for our form)
                url: getServer() +'v1-4/listing.php', // the url where we want to POST
                data: formData, // our data object
                dataType: 'json', // what type of data do we expect back from the server
                encode: true
            });
            // using the done promise callback
            ajaxIndex.done(function(dataIndex) {

                // log data to the console so we can see
                // console.log(dataIndex);
				
				window.localStorage.setItem( 'askformail', dataIndex.askformail);

				if (device.platform == 'android' || device.platform == 'Android' || device.platform == 'amazon-fireos') {
					window.localStorage.setItem( 'quality', dataIndex.quality_android);
				} else {
					window.localStorage.setItem( 'quality', dataIndex.quality_ios);
				}

                // here we will handle errors and validation messages
                if (!dataIndex.success) {

                    // handle errors for name ---------------
                    if (dataIndex.errors.name) {
                        $('#_name-group').append('<div class="yellow-notif">' + dataIndex.errors.name + '</div>'); // add the actual error message under our input
                    }

                    // handle errors for superhero alias ---------------
                    if (dataIndex.errors.deviceid) {
                        $('#_deviceid-group').append('<div class="yellow-notif">' + dataIndex.errors.deviceid + '</div>'); // add the actual error message under our input
                    }

                } else {
                    // ALL GOOD! just show the success message!
                    $(".table").remove();
					if (dataIndex.number > 0) {
						$('#_noGroup').remove();
						$('#_result').append('<table class="table"><tbody id="_getTables"></tbody></table>');
						$('body').prepend('<div class="dad"><div class="son1"></div><div class="son2"></div></div>');
							
							for (var i = 0; i < dataIndex.name.length; i++) {
							
								var errorCodeList;
								switch (dataIndex.owner[i]) {
										case "code18":
											errorCodeList = "";
											break;
										case "code19":
											errorCodeList = "";
											break;
										case "code20":
											errorCodeList = "";
											break;
								}
							
								if (dataIndex.groups[i] > 1) {
									$('#_getTables').append('<tr class="trHeight" id="' + dataIndex.name[i] + '"><td class="tdWidth1"><div class="' + dataIndex.name[i] + '"><i>Notifications</i><br><img id="_push" src="./img/' + dataIndex.activated[i] + '"><img id="_loadingPush" src="./img/loader.gif"><div class="members"><b>' + dataIndex.groups[i] + '</b> Membres</div></div></td><td id="_tdWidth2"><div id="_fitWithArrow" class="_X_' + dataIndex.ownerOwned[i] + '_Y_ ' + dataIndex.ownerCheck[i] + ' _Z_' + dataIndex.name[i] + ' _A_' + dataIndex.secret[i] + '"><b class="capital">' + dataIndex.name[i] + '</b><br>' + dataIndex.secret[i] + '<br>' + errorCodeList + '</div><div class="buttonErasing white bold _ButtonErase_' + dataIndex.name[i] + '">Supprimer</div></td></tr>');
								} else {
									$('#_getTables').append('<tr class="trHeight" id="' + dataIndex.name[i] + '"><td class="tdWidth1"><div class="' + dataIndex.name[i] + '"><i>Notifications</i><br><img id="_push" src="./img/' + dataIndex.activated[i] + '"><img id="_loadingPush" src="./img/loader.gif"><div class="members"><b>' + dataIndex.groups[i] + '</b> Membre</div></div></td><td id="_tdWidth2"><div id="_fitWithArrow" class="_X_' + dataIndex.ownerOwned[i] + '_Y_ ' + dataIndex.ownerCheck[i] + ' _Z_' + dataIndex.name[i] + ' _A_' + dataIndex.secret[i] + '"><b class="capital">' + dataIndex.name[i] + '</b><br>' + dataIndex.secret[i] + '<br>' + errorCodeList + '</div><div class="buttonErasing white bold _ButtonErase_' + dataIndex.name[i] + '">Supprimer</div></td></tr>');
								}
								
								$('._ButtonErase_' + dataIndex.name[i] + '').click(function() {
									var groupsErase = $(this).attr("class");
									var groupFilter1 = groupsErase.split("_ButtonErase_");
									var groupFilter2 = groupFilter1[1];
									leaveGroup(groupFilter2);
								});
								$('.' + dataIndex.name[i] + '').click(function() {
									var groupsPush = $(this).attr("class");
									jQuery(this).children("#_push").hide();
									jQuery(this).children("#_loadingPush").show();
									leavePush(groupsPush);
								});
								$('#' + dataIndex.name[i] + '').hammer().on("swipeleft", function(event) {
									var groups = $(this).attr("id");
									$('.' + groups + '').hide();
									$('._Z_' + groups + '').hide();
									//$('._Z_' + groups + '').next(".arrowLaunchWidth").hide();
									$('#' + groups + '').removeClass("buttonDeleteGroups");
									$('#' + groups + '').addClass("buttonDeleteGroups");
									$('._ButtonErase_' + groups + '').show();
									resetAllDeletingInstances(groups);
								});
								$('#' + dataIndex.name[i] + '').hammer().on("swiperight", function(event) {
									var groups1 = $(this).attr("id");
									$('.' + groups1 + '').show();
 									$('._Z_' + groups1 + '').show();
									//$('._Z_' + groups1 + '').next(".arrowLaunchWidth").show();
									$('#' + groups1 + '').removeClass("buttonDeleteGroups");
									$('._ButtonErase_' + groups1 + '').hide();
								});
								$('._Z_' + dataIndex.name[i] + '').click(function() {
									var redirectMessages = $(this).attr("class");
									
									var getSecret0 = redirectMessages.split("_A_");
									var getSecret = getSecret0[1];
									
									var groupSplit = redirectMessages.split("_Z_");
									var clusterChoice0 = groupSplit[1];
									var clusterChoice1 = clusterChoice0.split(" _A_");
									var clusterChoice = clusterChoice1[0];
									
									var groupSplit2 = redirectMessages.split("_Y_ ");
									var groupSplit3 = groupSplit2[1];
									var groupSplit4 = groupSplit3.split(" _Z_");
									var ownerRights = groupSplit4[0];
									
									var groupSplit5 = redirectMessages.split("_X_");
									var groupSplit6 = groupSplit5[1];
									var groupSplit7 = groupSplit6.split("_Y_");
									var ownerOwned = groupSplit7[0];
									
									sendRedirect(clusterChoice, getSecret, ownerRights, ownerOwned);
								});
							}
							addRedirect();
					} else {
						$('#_result').append('<div class="center no-cluster"><h3 class="red bold">JE SUIS ORGANISATEUR</h3><h4>Rendez-vous sur <b>www.popcluster.eu</b> pour créer votre événement.</h4><br><h3 class="red bold">JE SUIS INVITÉ</h3><h4>J\'ai déjà des identifiants pour mon événement.</h4><br><img class="center start-add addRedirectStart" src="img/add-start-fr.png"></div>');
						addRedirect();
					}
					$('#_loader').hide();
                }
				clearTimeout(timerIndex);
            });
        ajaxIndex.fail(function(dataIndex) {
			clearTimeout(timerIndex);
			showError();
			retrieveServer();
        });

}

function resetAllDeletingInstances(resetCluster) {

	setTimeout(function() {
		$('.' + resetCluster + '').show();
/* 		$('._Z_' + resetCluster + '').children("#_fitWithArrow").show();
		$('._Z_' + resetCluster + '').children(".arrowLaunchWidth").show(); */
		$('._Z_' + resetCluster + '').show();
		//$('._Z_' + resetCluster + '').next(".arrowLaunchWidth").show();
		$('#' + resetCluster + '').removeClass("buttonDeleteGroups");
		$('._ButtonErase_' + resetCluster + '').hide();
	}, 6000);

}

function leavePush(group) {

	var formData = {
		'name': group,
		'deviceid'			: window.localStorage.getItem( 'device' ),
		'olddeviceid'		: window.localStorage.getItem( 'olddevice' ),
		'uuid'				: window.localStorage.getItem( 'uuid' ),
		'olduuid'			: window.localStorage.getItem( 'olduuid' ),
		'devicePlatform'	: window.localStorage.getItem( 'devicePlatform' )
	};

	$.ajax({
		type: 'POST',
		url: getServer() +'v1-4/leavePush.php',
		data: formData,
		dataType: 'json',
		encode: true
	})
	.done(function(dataPush) {
		refreshing();
	})
	.fail(function(dataPush) {
		retrieveServer();
	});

}

function leaveGroup(group) {

    navigator.notification.confirm("Êtes-vous certain de vouloir supprimer cet événement ?", onConfirm, "Confirmation", "Oui,Non");

    function onConfirm(buttonIndex) {
        if (buttonIndex != 1) {
            navigator.notification.alert("Ok, on le garde pour vous !", alertCallback, "Annulation", "Merci !");
        } else {

            var formData = {
                'name': group,
				'deviceid'			: window.localStorage.getItem( 'device' ),
				'olddeviceid'		: window.localStorage.getItem( 'olddevice' ),
				'uuid'				: window.localStorage.getItem( 'uuid' ),
				'olduuid'			: window.localStorage.getItem( 'olduuid' ),
				'devicePlatform'	: window.localStorage.getItem( 'devicePlatform' )
            };

			$.ajax({
				type: 'POST', // define the type of HTTP verb we want to use (POST for our form)
				url: getServer() +'v1-4/leaveGroup.php', // the url where we want to POST
				data: formData, // our data object
				dataType: 'json', // what type of data do we expect back from the server
				encode: true
			})
			.done(function(dataGroup) {
				refreshing();
			})
			.fail(function(dataGroup) {
				retrieveServer();
			});
        }
    }
}






/*  */
/*  */
/* SEND FUNCTION */
/*  */
/*  */


function sendRedirect(clusterChoice, getSecret, ownerRights, ownerOwned) {

	$('.dad').remove();
	$('#_result').empty();
	$('#_titleListing').hide();
	$('#_titleSend').empty();
	$('.addRedirect').hide();
	$('.return').show();
	$('.inviteRedirect').show();
	$('#_titleSend').append(clusterChoice);
	$('#_titleSend').show();
	$('.outputMessages').show();
	$('.return').css('position', 'fixed');
	$('.title').css('height', '12%');
		
	analytics.startTrackerWithId('UA-53293565-1');
	analytics.trackView('Send');
	window.localStorage.setItem( 'currentScreen' , 'send');
	
	$('#_notif').attr("placeholder", "Ecrivez votre message");
	$('#_sign').attr("placeholder", "Signature (Optionnelle)");
	$('#_widthCluster').append("Cluster");
	//$('#_widthNotif').append("Pop");
	
	$('#_notif').maxlength({
		threshold: 80,
		placement: 'bottom'
	});

	$('#_sign').maxlength({
		threshold: 20,
		placement: 'bottom'
	});
	
/* 	$('#_activateSign').change(function(){
		if ($('#_activateSign').is(':checked') == true){
			$('#_sign').prop('disabled', false);
		} else {
			$('#_sign').prop('disabled', true);
		}
	}); */
	
	if (ownerRights == 1 || ownerOwned == 1) {
		$('#_formsend').show();
		callServerSend(clusterChoice);
		var privateMessages = "0";
	} else {
		var privateMessages = "1";
	}
	var currentSendCluster = clusterChoice;
	var currentSendClusterMin = currentSendCluster;
	var currentSendCluster = currentSendCluster.toUpperCase();
	window.localStorage.setItem( 'currentSendCluster' , currentSendCluster);
	window.localStorage.setItem( 'currentSendClusterMin' , currentSendClusterMin);
	window.localStorage.setItem( 'currentSecret' , getSecret);
	
	callServerMessages(clusterChoice, privateMessages);
}


function callServerSend(clusterChoice) {

if ( ( window.localStorage.getItem( 'signature' ) ) != null ) {
	$("#_sign").attr("value", "" );
	$("#_sign").attr("value", window.localStorage.getItem( 'signature' ) );
}

$("#_notif").on('blur',function(){
	$('.outputMessages').css('margin-bottom', '100%');
	window.scrollTo(0,0);
	$('.outputMessages').css('margin-bottom', '0');
	$('body').off('touchmove');
});

$("#_sign").on('blur',function(){
	$('.outputMessages').css('margin-bottom', '100%');
	window.scrollTo(0,0);
	$('.outputMessages').css('margin-bottom', '0');
	$('body').off('touchmove');
});

$("#_notif").on('focus',function(){
	$('body').on('touchmove', function(evt) {
		evt.preventDefault();
	});
});

$("#_sign").on('focus',function(){
	$('body').on('touchmove', function(evt) {
		evt.preventDefault();
	});
});
					if (window.localStorage.getItem( 'askformail' ) == 1) {
						if (window.localStorage.getItem( 'email' ) == null) {
							askEmail();
						} else {
							var displayMessage = 0;
							var isSent = sendGuestEmail(window.localStorage.getItem( 'email' ), displayMessage);
						}
					}

					function onPrompt(results) {
						if (results.buttonIndex == 1) {
							var emailRemoveSpaces = results.input1.replace(/\s+/g, '');
							var testingMail = validateEmail(emailRemoveSpaces);
							if (testingMail == true) {
								window.localStorage.setItem( 'email', emailRemoveSpaces);
								var displayMessage = 1;
								var isSent = sendGuestEmail(emailRemoveSpaces, displayMessage);
							} else {
								navigator.notification.alert("Votre Adresse email est incorrecte.", askEmail, "Email", "Ok");
							}
						}
					}

					function validateEmail(email) {
						var re = /^([\w-]+(?:\.[\w-]+)*)@((?:[\w-]+\.)*\w[\w-]{0,66})\.([a-z]{2,6}(?:\.[a-z]{2})?)$/i;
						return re.test(email);
					}
					
					function askEmail() {
						navigator.notification.prompt(
							'Comme vos amis, recevez les photos de l\'événement par mail !',  // message
							onPrompt,                  // callback to invoke
							'PHOTOS',            // title
							['Valider','Plus Tard'],             // buttonLabels
							'Votre email'                 // defaultText
						);
					}
					
					function sendGuestEmail(myemail, displayMessage) {

						var formData = {
							'cluster': clusterChoice,
							'email': myemail
						};

						var ajaxEmail = null;

						var timerEmail = setTimeout(function(){
							if (ajaxEmail != null) {
								ajaxEmail.abort();
							}
						},10000);

						ajaxEmail = $.ajax({
										type: 'POST',
										url: getServer() +'v1-4/email.php',
										data: formData,
										dataType: 'json',
										encode: true
									});
						ajaxEmail.done(function(dataEmail) {
							clearTimeout(timerEmail);
							if (displayMessage == 1) {
								navigator.notification.alert("Nous vous enverrons prochainement un mail contenant un accès aux photos !", alertCallback, "Merci !", "Ok");
							}
						});
						ajaxEmail.fail(function(dataEmail) {
							return;
						});
					}

    $('#_formsend').submit(function(event) {
	
	var idCheck = randString(7);
	
	var catchNotif = $('input[name=notif]').val();
	
/* 	if (($('#_activateSign').is(':checked') == true) && ( !$.trim( $('#_sign').val() ) == '' )) {
		var signature = $('input[name=sign]').val();
		var signature = $.trim(signature);
		window.localStorage.setItem( 'signature' , signature);
		var catchAll = catchNotif + ' ['+ signature +']';
	} else {
		var signature = "";
		var catchAll = catchNotif;
	} */
	
	if (!$.trim( $('#_sign').val() ) == '' ) {
		var signature = $('input[name=sign]').val();
		var signature = $.trim(signature);
		window.localStorage.setItem( 'signature' , signature);
		var catchAll = catchNotif + ' ['+ signature +']';
	} else {
		var signature = "";
		var catchAll = catchNotif;
	}
	
	if ($('input[name=notif]').val().length > 0) {
	
		var check1 = catchAll.toLowerCase().indexOf("http://");
		var spliter1 = catchAll.toLowerCase().split("http://");

		if (check1 != "-1") {
			
			var htmlRight1= "";
			htmlRight1= spliter1[1];
			var htmlLeft1= "";
			htmlLeft1= spliter1[0];
			htmlLeft1= capitaliseFirstLetter(htmlLeft1);
			var corpus1= "";
			corpus1= htmlRight1.split(" ");
			var result1= "";
			result1= corpus1[0];
			var resultOther = "";
			resultOther = corpus1[1] ? corpus1[1] : '';
			var resulting = "";
			resulting = "http://"+ result1;
			$('.outputMessages').prepend('<div id="_'+ idCheck +'"><div id="_errorColor'+ idCheck +'" class="insideMessages message messageOnRight"><div class="messsageNotSent" id="_messsageNotSent'+ idCheck +'">Votre connexion est instable. Votre Pop n\'a pas été envoyé.</div><div id="_errorHide'+ idCheck +'"><img class="loaderMessage" id="_loaderMessage'+ idCheck +'" src="img/loader.gif">&nbsp;&nbsp;'+ htmlLeft1 +'<b><span id="_navigatorLauch'+ idCheck +'" class="'+ resulting +'">LIEN&nbsp;</span></b>'+ resultOther +'</div></div><div id="_displayTime'+ idCheck +'" class="insideMessages messageOnRight date">' + displayTime() + '</div></div>');
			showDateDoubleTap(idCheck);
			$( '#_navigatorLauch'+ idCheck +'' ).click(function() {
				var currentFileCheck = $(this).attr("class");
				window.open(currentFileCheck, '_system', 'location=no');
			});

		} else {
			$('.outputMessages').prepend('<div id="_'+ idCheck +'"><div id="_errorColor'+ idCheck +'" class="insideMessages message messageOnRight"><div class="messsageNotSent" id="_messsageNotSent'+ idCheck +'">Votre connexion est instable. Votre Pop n\'a pas été envoyé.</div><div id="_errorHide'+ idCheck +'"><img class="loaderMessage" id="_loaderMessage'+ idCheck +'" src="img/loader.gif">&nbsp;&nbsp;'+ catchAll +'</div></div><div id="_displayTime'+ idCheck +'" class="insideMessages messageOnRight date">' + displayTime() + '</div></div>');
			$('#_loaderMessage'+ idCheck).show();
			showDate(idCheck);
		}
	}
	
	$("#_notif").val("");
	$("#_notif").attr("value", "");

        $('#_notif-group').removeClass("has-error");
        $('#_sign-group').removeClass("has-error");
		$('.yellow-notif').remove();

        var formData = {
            'name': clusterChoice,
            'notif': catchNotif,
			'sign': signature,
            'deviceid'			: window.localStorage.getItem( 'device' ),
			'olddeviceid'		: window.localStorage.getItem( 'olddevice' ),
			'uuid'				: window.localStorage.getItem( 'uuid' ),
			'olduuid'			: window.localStorage.getItem( 'olduuid' ),
            'devicePlatform'	: window.localStorage.getItem( 'devicePlatform' )
        };

var ajaxMessages = null;

var timerMessages  = setTimeout(function(){
	if (ajaxMessages != null) {
		ajaxMessages.abort();
	}
},10000);
		
ajaxMessages = $.ajax({
                type: 'POST',
                url: getServer() +'v1-4/send.php',
                data: formData,
                dataType: 'json',
                encode: true
            });
            ajaxMessages.done(function(dataSend) {

                 if (!dataSend.success) {

                    if (dataSend.errors.notif) {
                        $('#_notif-group').addClass("has-error");
						if (dataSend.errors.notif == "code21") {
							$('#_notif-group').append('<div class="yellow-notif">Le caractère suivant n\'est pas autorisé : §.</div>');
							$('#_'+ idCheck).remove();
						}
                    }
					
                    if (dataSend.errors.sign) {
                        $('#_sign-group').addClass("has-error");
						if (dataSend.errors.sign == "code21") {
							$('#_charPara').append('<div class="yellow-notif">Le caractère suivant n\'est pas autorisé : §.</div>');
							$('#_'+ idCheck).remove();
						}
                    }

                } else {

					if (dataSend.already == "1") {
						$('#_loaderMessage'+ idCheck).hide();
						console.log(dataSend);
					} else {
						navigator.notification.alert(dataSend.message, alertCallback, "Échec", "Ok");
					}

                }
				clearTimeout(timerMessages);
            });
			ajaxMessages.fail(function(dataSend) {
				clearTimeout(timerMessages);
				$('#_errorHide'+ idCheck).hide();
				$('#_errorColor'+ idCheck).removeClass("messageOnRight");
				$('#_errorColor'+ idCheck).addClass("messageOnRightError");
				$('#_displayTime'+ idCheck).addClass("messageOnRightError");
				$('#_messsageNotSent'+ idCheck).show();
				retrieveServer();
			});
        event.preventDefault();
    });
}






/*  */
/*  */
/* MESSAGES FUNCTION */
/*  */
/*  */

function showDate(i) {
	$('#_' + i + '').click(function() {
		jQuery(this).children(".message").hide();
		jQuery(this).children(".date").show();
		setTimeout(function() {
				$('#_' + i + '').children(".date").hide();
				$('#_' + i + '').children(".message").show();
		}, 3000);
	});
}

function showDateDoubleTap(i) {
	$('#_' + i + '').hammer().on("doubletap", function(event) {
		jQuery(this).children(".message").hide();
		jQuery(this).children(".date").show();
		setTimeout(function() {
				$('#_' + i + '').children(".date").hide();
				$('#_' + i + '').children(".message").show();
		}, 3000);
	});
}

function callServerMessages(clusterChoice, privateMessages) {

analytics.startTrackerWithId('UA-53293565-1');
analytics.trackEvent('Messages', clusterChoice);

$('.return').click(function() {
	refreshing();
});

$('.inviteRedirect').click(function() {
	$('#_formsend').hide();
	$('.inviteRedirect').hide();
	$('.outputMessages').hide();
	$('.return').hide();
	callInvite()
});
		
var ajaxMessagesReceived = null;

var timerMessagesReceived = setTimeout(function(){
	if (ajaxMessagesReceived != null) {
		ajaxMessagesReceived.abort();
	}
},10000);

        var formData = {
			'group': clusterChoice,
            'deviceid'			: window.localStorage.getItem( 'device' ),
			'olddeviceid'		: window.localStorage.getItem( 'olddevice' ),
			'uuid'				: window.localStorage.getItem( 'uuid' ),
			'olduuid'			: window.localStorage.getItem( 'olduuid' ),
            'devicePlatform'	: window.localStorage.getItem( 'devicePlatform' )
        };

		$('#_loaderOutputMessages').show();
		
ajaxMessagesReceived = $.ajax({
						type: 'POST',
						url: getServer() +'v1-4/messages.php',
						data: formData,
						dataType: 'json',
						encode: true
					});
					ajaxMessagesReceived.done(function(dataMessages) {
			
						if (dataMessages.number > 0) {
								for (var i = 0; i < dataMessages.messages.length; i++) {
									var j = i + 1;
									if ( ( dataMessages.messages[i].startsWith("http://") || dataMessages.messages[i].startsWith("https://") ) && ( dataMessages.messages[i].endsWith(".jpg") || dataMessages.messages[i].endsWith(".jpeg") || dataMessages.messages[i].endsWith(".png") || dataMessages.messages[i].endsWith(".gif") || dataMessages.messages[i].endsWith(".JPG") || dataMessages.messages[i].endsWith(".JPEG") || dataMessages.messages[i].endsWith(".PNG") || dataMessages.messages[i].endsWith(".GIF") ) ) {
										if (dataMessages.users[i] == "0") {
											if (dataMessages.pack[i] == 1) {
											var thumbWithOrWithoutLogo = dataMessages.messages[i].replace("http://popcluster.eu/up/thumbs/", "http://popcluster.eu/up/thumbs-logo/");
											var imgWithOrWithoutLogo = dataMessages.messages[i].replace("http://popcluster.eu/up/thumbs/", "http://popcluster.eu/up/uploads-logo/");
											} else {
											var thumbWithOrWithoutLogo = dataMessages.messages[i];
											var imgWithOrWithoutLogo = dataMessages.messages[i].replace("http://popcluster.eu/up/thumbs/", "http://popcluster.eu/up/uploads/");
											}
											var fileNameGenerator = randString(6);
											$('.outputMessages').append('<div id="_' + i + '"><div class="message insideMessages messageOnLeft message'+ j +'"><img id="_navigatorLauch'+ i +'" class="lazy filter" width="100px" data-original="' + thumbWithOrWithoutLogo + '"><div style="display: inline-block;"><button onclick="window.plugins.socialsharing.shareViaFacebook( \'\', \''+ imgWithOrWithoutLogo +'\' /* img */, \'http://popcluster.eu\' /* url */, function() {console.log(\'share ok\')}, function(errormsg){alert(errormsg)})" style="margin-left: 10px;" class="btn btn-sm btn-primary"><i class="fa fa-facebook"></i>&nbsp;&nbsp;<b>Partager</b></button><br><button onclick="DownloadFile(\''+ imgWithOrWithoutLogo +'\', \'PopCluster\', \'PopCluster-'+ fileNameGenerator +'\')" style="margin-left: 10px; margin-top: 10px;" class="btn btn-sm btn-success"><i class="fa fa-download"></i>&nbsp;&nbsp;<b>Télécharger</b></button></div></div><div class="insideMessages messageOnLeft message'+ j +' date">' + dataMessages.datetime[i] + '</div></div>');
											$(function() {
												$("img.lazy").lazyload();
											});
											showDateDoubleTap(i);
											$( '#_navigatorLauch'+ i +'' ).click(function() {
												var currentPicture = $(this).attr("src");
												if ( currentPicture.startsWith("http://popcluster.eu/up/thumbs/") ) {
													var imagePoorQuality = currentPicture.replace("http://popcluster.eu/up/thumbs/", "http://popcluster.eu/up/uploads/");
												} else {
													var imagePoorQuality = currentPicture.replace("http://popcluster.eu/up/thumbs-logo/", "http://popcluster.eu/up/uploads-logo/");
												}
												var pictureResizedFromPhp = "http://popcluster.eu/up/resize.php?picture=" + imagePoorQuality;
												window.open(pictureResizedFromPhp, '_blank', 'location=no');
											});
										} else {
											if (dataMessages.pack[i] == 1) {
											var thumbWithOrWithoutLogo = dataMessages.messages[i].replace("http://popcluster.eu/up/thumbs/", "http://popcluster.eu/up/thumbs-logo/");
											var imgWithOrWithoutLogo = dataMessages.messages[i].replace("http://popcluster.eu/up/thumbs/", "http://popcluster.eu/up/uploads-logo/");
											} else {
											var thumbWithOrWithoutLogo = dataMessages.messages[i];
											var imgWithOrWithoutLogo = dataMessages.messages[i].replace("http://popcluster.eu/up/thumbs/", "http://popcluster.eu/up/uploads/");
											}
											var fileNameGenerator = randString(6);
											$('.outputMessages').append('<div id="_' + i + '"><div class="message insideMessages messageOnRight message'+ j +'"><img id="_navigatorLauch'+ i +'" class="lazy filter" width="100px" data-original="' + thumbWithOrWithoutLogo + '"><div style="display: inline-block;"><button onclick="window.plugins.socialsharing.shareViaFacebook( \'\', \''+ imgWithOrWithoutLogo +'\' /* img */, \'http://popcluster.eu\' /* url */, function() {console.log(\'share ok\')}, function(errormsg){alert(errormsg)})" style="margin-left: 10px;" class="btn btn-sm btn-primary"><i class="fa fa-facebook"></i>&nbsp;&nbsp;<b>Partager</b></button><br><button onclick="DownloadFile(\''+ imgWithOrWithoutLogo +'\', \'PopCluster\', \'PopCluster-'+ fileNameGenerator +'\')" style="margin-left: 10px; margin-top: 10px;" class="btn btn-sm btn-success"><i class="fa fa-download"></i>&nbsp;&nbsp;<b>Télécharger</b></button></div></div><div class="insideMessages messageOnRight message'+ j +' date">' + dataMessages.datetime[i] + '</div></div>');
											$(function() {
												$("img.lazy").lazyload();
											});
											showDateDoubleTap(i);
											$( '#_navigatorLauch'+ i +'' ).click(function() {
												var currentPicture = $(this).attr("src");
												if ( currentPicture.startsWith("http://popcluster.eu/up/thumbs/") ) {
													var imagePoorQuality = currentPicture.replace("http://popcluster.eu/up/thumbs/", "http://popcluster.eu/up/uploads/");
												} else {
													var imagePoorQuality = currentPicture.replace("http://popcluster.eu/up/thumbs-logo/", "http://popcluster.eu/up/uploads-logo/");
												}
												var pictureResizedFromPhp = "http://popcluster.eu/up/resize.php?picture=" + imagePoorQuality;
												window.open(pictureResizedFromPhp, '_blank', 'location=no');
											});
										}
									} else {
										var check1 = dataMessages.messages[i].toLowerCase().indexOf("http://");
										var spliter1 = dataMessages.messages[i].toLowerCase().split("http://");

										if (check1 != "-1") {
											
											var htmlRight1= "";
											htmlRight1= spliter1[1];
											var htmlLeft1= "";
											htmlLeft1= spliter1[0];
											htmlLeft1= capitaliseFirstLetter(htmlLeft1);
											var corpus1= "";
											corpus1= htmlRight1.split(" ");
											var result1= "";
											result1= corpus1[0];
											var resultOther = "";
											resultOther = corpus1[1] ? corpus1[1] : '';
											var resulting = "";
											resulting = "http://"+ result1;
											$('.outputMessages').append('<div id="_' + i + '"><div class="message insideMessages messageOnLeft message'+ j +'">'+ htmlLeft1 +'<b><span id="_navigatorLauch'+ i +'" class="'+ resulting +'">LIEN&nbsp;</span></b>'+ resultOther +'</div><div class="insideMessages messageOnLeft message'+ j +' date">' + dataMessages.datetime[i] + '</div></div>');
											showDateDoubleTap(i);
											$( '#_navigatorLauch'+ i +'' ).click(function() {
												var currentFileCheck = $(this).attr("class");
												window.open(currentFileCheck, '_system', 'location=no');
											});

										} else {
											if (dataMessages.users[i] == "0") {
												$('.outputMessages').append('<div id="_' + i + '"><div class="message insideMessages messageOnLeft message'+ j +'">' + dataMessages.messages[i] + '</div><div class="insideMessages messageOnLeft message'+ j +' date">' + dataMessages.datetime[i] + '</div></div>');
												showDate(i);
											} else {
												$('.outputMessages').append('<div id="_' + i + '"><div class="message insideMessages messageOnRight message'+ j +'">' + dataMessages.messages[i] + '</div><div class="insideMessages messageOnRight message'+ j +' date">' + dataMessages.datetime[i] + '</div></div>');
												showDate(i);
											}
										}
									}
								}
								//$('.outputMessages').append('<div class="insideMessages bold center italic">Les messages s\'effacent progressivement&nbsp;!</div>');
						} else {
							$('.outputMessages').append('<div class="insideMessages bold center italic" id="_nomessage">Vous n\'avez pas de nouveau message dans ce Cluster&nbsp;!&nbsp;</div>');
						}
						if (privateMessages == 1) {
							$('.outputMessages').addClass("privateCluster");
							$('.outputMessages').append('<div class="insideMessages bold center italic">Ce Cluster est privé, personne d\'autre que le propriétaire ne peut envoyer de Pop\'s !</div>');
							$('.outputMessages').show();
						}
						clearTimeout(timerMessagesReceived);
						$('#_loaderOutputMessages').hide();
					});
					ajaxMessagesReceived.fail(function(dataMessages) {
						clearTimeout(timerMessagesReceived);
						showError();
						retrieveServer();
	});
}



/*  */
/*  */
/* INVITE FUNCTION */
/*  */
/*  */


function callInvite() {

$('#_titleSend').hide();
$('#_titleInvite').show();

$('#_widthCluster').append("Cluster");
$('#_widthFriend').append("Ami");
$('#_searchFriend').append("Rechercher");
$('.returnInvite').attr("src", "img/return-fr.png");
$('#_spanInput').append("Chercher");
$('#_searchfilter').attr("placeholder", "Chercher des amis");

analytics.startTrackerWithId('UA-53293565-1');
analytics.trackView('Invite');
window.localStorage.setItem( 'currentScreen' , 'invite');

$('#_searchImput').show();
$('#_contactList').show();
$('.returnInvite').show();
$('#_loader2').show();
$('.returnInvite').css('position', 'fixed');
$('.title').css('position', 'fixed');


getFriends();

$('.returnInvite').click(function() {
	refreshing();
});

$("#_searchfilter").on('blur',function(){
	$('.divScrollable').css('margin-bottom', '100%');
	window.scrollTo(0,0);
	$('.divScrollable').css('margin-bottom', '0');
	$('body').off('touchmove');
});

$("#_searchfilter").on('focus',function(){
	$('body').on('touchmove', function(evt) {
		evt.preventDefault();
	});
});

$('input').keyup(function() {
  
	if ( $("li").hasClass("radius-first")) {
        $("#_formFriends > li").removeClass('radius-first');                              
    }
	
	if ( $("li").hasClass("radius-last")) {
        $("#_formFriends > li").removeClass('radius-last');                              
    }

    filter(this);
});

function filter(element) {
    var value = $(element).val().toLowerCase().replace(/\s+/g, '');
	var compteur=0;
	var compteur2=0;
	
    $("#_formFriends > li").each(function () {
        
        if ($(this).text().toLowerCase().replace(/\s+/g, '').indexOf(value) > -1) {
			compteur2=++compteur2;
        }
    });
    
    $("#_formFriends > li").each(function () {
        
        if ($(this).text().toLowerCase().replace(/\s+/g, '').indexOf(value) > -1) {
	
			if(compteur==0){
                $(this).addClass('radius-first');
            }
            
            compteur=++compteur;
			
            if(compteur==compteur2){
               $(this).addClass("radius-last");
            }
			
			$(this).css("background-color", "#f9f9f9").show();
			
        } else {
            $(this).hide();
        }
    });
}

function getFriends() {
    // find all contacts with 'Bob' in any name field
    var options = new ContactFindOptions();
    options.filter = "";
    options.multiple = true;
    var fields = ["displayName", "phoneNumbers"];
    navigator.contacts.find(fields, onSuccess, onError, options);
}

function getName(c) {
	var name = c.displayName;
	if(!name || name === "") {
		if(c.name.formatted) return c.name.formatted;
		if(c.name.givenName && c.name.familyName) return c.name.givenName +" "+c.name.familyName;
		return "Nameless";
	}
	return name;
}

function onSuccess(contacts) {
	contacts.sort(function(a, b){
	if(getName(a) < getName(b)) return -1;
	if(getName(a) > getName(b)) return 1;
	return 0;
	})
	
	$('#_loader2').hide();
	$('#_contactList').append('<ul id="_formFriends"></ul>');
	
	var groupSMS = window.localStorage.getItem( 'currentSendClusterMin' );
	var secretSMS = window.localStorage.getItem( 'currentSecret' );
	
	for (var i = 0; i < contacts.length; i++) {
		if (contacts[i].phoneNumbers != null) {
			$('#_formFriends').append('<li class="liContacts" onclick="window.plugins.socialsharing.shareViaSMS(\'Je viens de créer un nouveau Cluster sur PopCluster pour nous ! ### Télécharge cette application ici : http://popcluster.eu/s.php ### Rejoins le Cluster ici : http://popcluster.eu/p.php?c='+ groupSMS + '&s=' + secretSMS + ' ### Cluster : ' + groupSMS + ' - Code : ' + secretSMS + '\', \'' + contacts[i].phoneNumbers[0].value + '\', function(msg) {console.log(\'ok: \' + msg)}, function(msg) {alert(\'error: \' + msg)})"><div class="tri"><div id="_centering1" class="bold">' + getName(contacts[i]) + '</div><br><div id="_centering2">' + contacts[i].phoneNumbers[0].value + '</div></div></li>');
		}
	}
}

// onError: Failed to get the contacts

function onError(contactError) {
	$('#_loader2').hide();
	$('#_result').append('<div class="center twenty-top"><h4 class="white">Vous avez désactivé l\'accès à vos contacts. Pour l\'activer : Réglages > Confidentialité > Contacts > PopCluster.</h4></div>');
    navigator.notification.alert("Vous avez désactivé l\'accès à vos contacts. Pour l\'activer : Réglages > Confidentialité > Contacts > PopCluster.", alertCallback, "Contacts verrouillés", "Merci !");
}
}


/*  */
/*  */
/* PUSH NOTIFICATIONS */
/*  */
/*  */


// APNS notifications for iOS
function onNotificationAPN(e) {
    if (e.alert) {

		if ( window.localStorage.getItem( 'currentSendCluster' ) == e.group && window.localStorage.getItem( 'currentScreen' ) == "send" ) {
			$("#_nomessage").remove();
			//$('.outputMessages').prepend('<div class="insideMessages messageOnLeft">' + e.alertinbox + '</div>');
			var selectedPop = randString(7);
			if ( ( e.alertinbox.startsWith("http://") || e.alertinbox.startsWith("https://") ) && ( e.alertinbox.endsWith(".jpg") || e.alertinbox.endsWith(".jpeg") || e.alertinbox.endsWith(".png") || e.alertinbox.endsWith(".gif") || e.alertinbox.endsWith(".JPG") || e.alertinbox.endsWith(".JPEG") || e.alertinbox.endsWith(".PNG") || e.alertinbox.endsWith(".GIF") ) ) {
				$('.outputMessages').prepend('<div id="_' + selectedPop + '"><div class="message insideMessages messageOnLeft"><img id="_navigatorLauch'+ selectedPop +'" class="filter" width="100px" src="' + e.alertinbox + '"></div><div class="insideMessages messageOnLeft date">' + displayTime() + '</div></div>');
				$( '#_navigatorLauch'+ selectedPop +'' ).click(function() {
					if ( e.alertinbox.startsWith("http://popcluster.eu/up/thumbs/") ) {
						var imagePoorQuality = e.alertinbox.replace("http://popcluster.eu/up/thumbs/", "http://popcluster.eu/up/uploads/");
					} else {
						var imagePoorQuality = e.alertinbox.replace("http://popcluster.eu/up/thumbs-logo/", "http://popcluster.eu/up/uploads-logo/");
					}
					var pictureResizedFromPhp = "http://popcluster.eu/up/resize.php?picture=" + imagePoorQuality;
					window.open(pictureResizedFromPhp, '_blank', 'location=no');
				});
				showDateDoubleTap(selectedPop);
				navigator.vibrate(3000);
			} else {
				var check1 = e.alertinbox.toLowerCase().indexOf("http://");
				var spliter1 = e.alertinbox.toLowerCase().split("http://");

				if (check1 != "-1") {
					
					var htmlRight1= "";
					htmlRight1= spliter1[1];
					var htmlLeft1= "";
					htmlLeft1= spliter1[0];
					htmlLeft1= capitaliseFirstLetter(htmlLeft1);
					var corpus1= "";
					corpus1= htmlRight1.split(" ");
					var result1= "";
					result1= corpus1[0];
					var resultOther = "";
					resultOther = corpus1[1] ? corpus1[1] : '';
					var resulting = "";
					resulting = "http://"+ result1;
					$('.outputMessages').prepend('<div id="_' + selectedPop + '"><div class="message insideMessages messageOnLeft">'+ htmlLeft1 +'<b><span id="_navigatorLauch'+ selectedPop +'" class="'+ resulting +'">LIEN&nbsp;</span></b>'+ resultOther +'</div><div class="insideMessages messageOnLeft date">' + displayTime() + '</div></div>');
					showDateDoubleTap(selectedPop);
					navigator.vibrate(3000);
					$( '#_navigatorLauch'+ selectedPop +'' ).click(function() {
						var currentFileCheck = $(this).attr("class");
						window.open(currentFileCheck, '_system', 'location=no');
					});
				} else {
					$('.outputMessages').prepend('<div id="_' + selectedPop + '"><div class="message insideMessages messageOnLeft">' + e.alertinbox + '</div><div class="insideMessages messageOnLeft date">' + displayTime() + '</div></div>');
					showDate(selectedPop);
					navigator.vibrate(3000);
				}
			}
		} else {
			navigator.notification.alert(e.alertinbox, alertCallback, e.group, 'Ok');
		}
    }

    if (e.sound) {
        var snd = new Media(e.sound);
        snd.play();
    }

    if (e.badge) {
        pushNotification.setApplicationIconBadgeNumber(successHandler, e.badge);
    }
}

// GCM notifications for Android
function onNotification(e) {

    switch (e.event) {
        case 'registered':
            if (e.regid.length > 0) {
				
				if ( ( window.localStorage.getItem( 'device' ) ) != ( e.regid ) ) {

					if ( ( window.localStorage.getItem( 'device' ) ) == null ) {
						// le code n'a jamais été enregistré car c'est la premiere utilisation, on doit alors l'enregistrer pour la première fois
						window.localStorage.setItem( 'device', e.regid);
						window.localStorage.setItem( 'olddevice', '');
						callUpdateCode();
					} else {
						// le code est différent de celui qui est enregistré, il a donc changé, on doit changer le nouveau code
						window.localStorage.setItem( 'olddevice', window.localStorage.getItem( 'device' ));
						window.localStorage.setItem( 'device', e.regid);
						callUpdateCode();
					}
					
				} else {
					window.localStorage.setItem( 'device', e.regid);
					window.localStorage.setItem( 'olddevice', '');
					callUpdateCode();
				}
				
            }
            break;

        case 'message':
            // if this flag is set, this notification happened while we were in the foreground.
            // you might want to play a sound to get the user's attention, throw up a dialog, etc.
            if (e.foreground) {
				if ( window.localStorage.getItem( 'currentSendCluster' ) == e.payload.title && window.localStorage.getItem( 'currentScreen' ) == "send" ) {
					$("#_nomessage").remove();
					//$('.outputMessages').prepend('<div class="insideMessages messageOnLeft">' + e.payload.message + '</div>');
					var selectedPop = randString(7);
					if ( ( e.payload.message.startsWith("http://") || e.payload.message.startsWith("https://") ) && ( e.payload.message.endsWith(".jpg") || e.payload.message.endsWith(".jpeg") || e.payload.message.endsWith(".png") || e.payload.message.endsWith(".gif") || e.payload.message.endsWith(".JPG") || e.payload.message.endsWith(".JPEG") || e.payload.message.endsWith(".PNG") || e.payload.message.endsWith(".GIF") ) ) {
						$('.outputMessages').prepend('<div id="_' + selectedPop + '"><div class="message insideMessages messageOnLeft"><img id="_navigatorLauch'+ selectedPop +'" class="filter" width="100px" src="' + e.payload.message + '"></div><div class="insideMessages messageOnLeft date">' + displayTime() + '</div></div>');
						$( '#_navigatorLauch'+ selectedPop +'' ).click(function() {
							if ( e.payload.message.startsWith("http://popcluster.eu/up/thumbs/") ) {
								var imagePoorQuality = e.payload.message.replace("http://popcluster.eu/up/thumbs/", "http://popcluster.eu/up/uploads/");
							} else {
								var imagePoorQuality = e.payload.message.replace("http://popcluster.eu/up/thumbs-logo/", "http://popcluster.eu/up/uploads-logo/");
							}
							var pictureResizedFromPhp = "http://popcluster.eu/up/resize.php?picture=" + imagePoorQuality;
							window.open(pictureResizedFromPhp, '_blank', 'location=no');
						});
						showDateDoubleTap(selectedPop);
						navigator.vibrate([200, 20, 200]);
					} else {
						var check1 = e.payload.message.toLowerCase().indexOf("http://");
						var spliter1 = e.payload.message.toLowerCase().split("http://");

						if (check1 != "-1") {
							
							var htmlRight1= "";
							htmlRight1= spliter1[1];
							var htmlLeft1= "";
							htmlLeft1= spliter1[0];
							htmlLeft1= capitaliseFirstLetter(htmlLeft1);
							var corpus1= "";
							corpus1= htmlRight1.split(" ");
							var result1= "";
							result1= corpus1[0];
							var resultOther = "";
							resultOther = corpus1[1] ? corpus1[1] : '';
							var resulting = "";
							resulting = "http://"+ result1;
							$('.outputMessages').prepend('<div id="_' + selectedPop + '"><div class="message insideMessages messageOnLeft">'+ htmlLeft1 +'<b><span id="_navigatorLauch'+ selectedPop +'" class="'+ resulting +'">LIEN&nbsp;</span></b>'+ resultOther +'</div><div class="insideMessages messageOnLeft date">' + displayTime() + '</div></div>');
							showDateDoubleTap(selectedPop);
							navigator.vibrate([200, 20, 200]);
							$( '#_navigatorLauch'+ selectedPop +'' ).click(function() {
								var currentFileCheck = $(this).attr("class");
								window.open(currentFileCheck, '_system', 'location=no');
							});
						} else {
							$('.outputMessages').prepend('<div id="_' + selectedPop + '"><div class="message insideMessages messageOnLeft">' + e.payload.message + '</div><div class="insideMessages messageOnLeft date">' + displayTime() + '</div></div>');
							showDate(selectedPop);
							navigator.vibrate([200, 20, 200]);
						}
					}
				} else {
					navigator.notification.alert(e.payload.message, alertCallback, e.payload.title, 'Ok');
				}
                // on Android soundname is outside the payload. 
                // On Amazon FireOS all custom attributes are contained within payload
                var soundfile = e.soundname || e.payload.sound;
                // if the notification contains a soundname, play it.
                // playing a sound also requires the org.apache.cordova.media plugin
                var my_media = new Media("/android_asset/www/" + soundfile);

                my_media.play();
            } else { // otherwise we were launched because the user touched a notification in the notification tray.
				if (e.coldstart) {
					if ( window.localStorage.getItem( 'currentSendCluster' ) == e.payload.title && window.localStorage.getItem( 'currentScreen' ) == "send" ) {
						$("#_nomessage").remove();
						//$('.outputMessages').prepend('<div class="insideMessages messageOnLeft">' + e.payload.message + '</div>');
						var selectedPop = randString(7);
						if ( ( e.payload.message.startsWith("http://") || e.payload.message.startsWith("https://") ) && ( e.payload.message.endsWith(".jpg") || e.payload.message.endsWith(".jpeg") || e.payload.message.endsWith(".png") || e.payload.message.endsWith(".gif") || e.payload.message.endsWith(".JPG") || e.payload.message.endsWith(".JPEG") || e.payload.message.endsWith(".PNG") || e.payload.message.endsWith(".GIF") ) ) {
							$('.outputMessages').prepend('<div id="_' + selectedPop + '"><div class="message insideMessages messageOnLeft"><img id="_navigatorLauch'+ selectedPop +'" class="filter" width="100px" src="' + e.payload.message + '"></div><div class="insideMessages messageOnLeft date">' + displayTime() + '</div></div>');
							$( '#_navigatorLauch'+ selectedPop +'' ).click(function() {
								if ( e.payload.message.startsWith("http://popcluster.eu/up/thumbs/") ) {
									var imagePoorQuality = e.payload.message.replace("http://popcluster.eu/up/thumbs/", "http://popcluster.eu/up/uploads/");
								} else {
									var imagePoorQuality = e.payload.message.replace("http://popcluster.eu/up/thumbs-logo/", "http://popcluster.eu/up/uploads-logo/");
								}
								var pictureResizedFromPhp = "http://popcluster.eu/up/resize.php?picture=" + imagePoorQuality;
								window.open(pictureResizedFromPhp, '_blank', 'location=no');
							});
							showDateDoubleTap(selectedPop);
							navigator.vibrate([200, 20, 200]);
						} else {
							var check1 = e.payload.message.toLowerCase().indexOf("http://");
							var spliter1 = e.payload.message.toLowerCase().split("http://");

							if (check1 != "-1") {
								
								var htmlRight1= "";
								htmlRight1= spliter1[1];
								var htmlLeft1= "";
								htmlLeft1= spliter1[0];
								htmlLeft1= capitaliseFirstLetter(htmlLeft1);
								var corpus1= "";
								corpus1= htmlRight1.split(" ");
								var result1= "";
								result1= corpus1[0];
								var resultOther = "";
								resultOther = corpus1[1] ? corpus1[1] : '';
								var resulting = "";
								resulting = "http://"+ result1;
								$('.outputMessages').prepend('<div id="_' + selectedPop + '"><div class="message insideMessages messageOnLeft">'+ htmlLeft1 +'<b><span id="_navigatorLauch'+ selectedPop +'" class="'+ resulting +'">LIEN&nbsp;</span></b>'+ resultOther +'</div><div class="insideMessages messageOnLeft date">' + displayTime() + '</div></div>');
								showDateDoubleTap(selectedPop);
								navigator.vibrate([200, 20, 200]);
								$( '#_navigatorLauch'+ selectedPop +'' ).click(function() {
									var currentFileCheck = $(this).attr("class");
									window.open(currentFileCheck, '_system', 'location=no');
								});
							} else {
								$('.outputMessages').prepend('<div id="_' + selectedPop + '"><div class="message insideMessages messageOnLeft">' + e.payload.message + '</div><div class="insideMessages messageOnLeft date">' + displayTime() + '</div></div>');
								showDate(selectedPop);
								navigator.vibrate([200, 20, 200]);
							}
						}
					} else {
						navigator.notification.alert(e.payload.message, alertCallback, e.payload.title, 'Ok');
					}
				} else {
					if ( window.localStorage.getItem( 'currentSendCluster' ) == e.payload.title && window.localStorage.getItem( 'currentScreen' ) == "send" ) {
						$("#_nomessage").remove();
						//$('.outputMessages').prepend('<div class="insideMessages messageOnLeft">' + e.payload.message + '</div>');
						var selectedPop = randString(7);
						if ( ( e.payload.message.startsWith("http://") || e.payload.message.startsWith("https://") ) && ( e.payload.message.endsWith(".jpg") || e.payload.message.endsWith(".jpeg") || e.payload.message.endsWith(".png") || e.payload.message.endsWith(".gif") || e.payload.message.endsWith(".JPG") || e.payload.message.endsWith(".JPEG") || e.payload.message.endsWith(".PNG") || e.payload.message.endsWith(".GIF") ) ) {
							$('.outputMessages').prepend('<div id="_' + selectedPop + '"><div class="message insideMessages messageOnLeft"><img id="_navigatorLauch'+ selectedPop +'" class="filter" width="100px" src="' + e.payload.message + '"></div><div class="insideMessages messageOnLeft date">' + displayTime() + '</div></div>');
							$( '#_navigatorLauch'+ selectedPop +'' ).click(function() {
								if ( e.payload.message.startsWith("http://popcluster.eu/up/thumbs/") ) {
									var imagePoorQuality = e.payload.message.replace("http://popcluster.eu/up/thumbs/", "http://popcluster.eu/up/uploads/");
								} else {
									var imagePoorQuality = e.payload.message.replace("http://popcluster.eu/up/thumbs-logo/", "http://popcluster.eu/up/uploads-logo/");
								}
								var pictureResizedFromPhp = "http://popcluster.eu/up/resize.php?picture=" + imagePoorQuality;
								window.open(pictureResizedFromPhp, '_blank', 'location=no');
							});
							showDateDoubleTap(selectedPop);
							navigator.vibrate([200, 20, 200]);
						} else {
							var check1 = e.payload.message.toLowerCase().indexOf("http://");
							var spliter1 = e.payload.message.toLowerCase().split("http://");

							if (check1 != "-1") {
								
								var htmlRight1= "";
								htmlRight1= spliter1[1];
								var htmlLeft1= "";
								htmlLeft1= spliter1[0];
								htmlLeft1= capitaliseFirstLetter(htmlLeft1);
								var corpus1= "";
								corpus1= htmlRight1.split(" ");
								var result1= "";
								result1= corpus1[0];
								var resultOther = "";
								resultOther = corpus1[1] ? corpus1[1] : '';
								var resulting = "";
								resulting = "http://"+ result1;
								$('.outputMessages').prepend('<div id="_' + selectedPop + '"><div class="message insideMessages messageOnLeft">'+ htmlLeft1 +'<b><span id="_navigatorLauch'+ selectedPop +'" class="'+ resulting +'">LIEN&nbsp;</span></b>'+ resultOther +'</div><div class="insideMessages messageOnLeft date">' + displayTime() + '</div></div>');
								showDateDoubleTap(selectedPop);
								navigator.vibrate([200, 20, 200]);
								$( '#_navigatorLauch'+ selectedPop +'' ).click(function() {
									var currentFileCheck = $(this).attr("class");
									window.open(currentFileCheck, '_system', 'location=no');
								});
							} else {
								$('.outputMessages').prepend('<div id="_' + selectedPop + '"><div class="message insideMessages messageOnLeft">' + e.payload.message + '</div><div class="insideMessages messageOnLeft date">' + displayTime() + '</div></div>');
								showDate(selectedPop);
								navigator.vibrate([200, 20, 200]);
							}
						}
					} else {
						navigator.notification.alert(e.payload.message, alertCallback, e.payload.title, 'Ok');
					}
				}
            }
            break;

        case 'error':
            break;

        default:
            break;
    }
}

function tokenHandler(result) {
    // Your iOS push server needs to know the token before it can push to this device
    // here is where you might want to send it the token for later use.
	
	if ( ( window.localStorage.getItem( 'device' ) ) != ( result ) ) {

		if ( ( window.localStorage.getItem( 'device' ) ) == null ) {
			// le code n'a jamais été enregistré car c'est la premiere utilisation, on doit alors l'enregistrer pour la première fois
			window.localStorage.setItem( 'device', result);
			window.localStorage.setItem( 'olddevice', '');
			callUpdateCode();
		} else {
			// le code est différent de celui qui est enregistré, il a donc changé, on doit changer le nouveau code
			window.localStorage.setItem( 'olddevice', window.localStorage.getItem( 'device' ));
			window.localStorage.setItem( 'device', result);
			callUpdateCode();
		}
		
	} else {
		window.localStorage.setItem( 'device', result);
		window.localStorage.setItem( 'olddevice', '');
		callUpdateCode();
	}
}

function callUpdateCode() {

	var formData = {
		'deviceid'			: window.localStorage.getItem( 'device' ),
		'olddeviceid'		: window.localStorage.getItem( 'olddevice' ),
		'uuid'				: window.localStorage.getItem( 'uuid' ),
		'olduuid'			: window.localStorage.getItem( 'olduuid' ),
		'devicePlatform'	: window.localStorage.getItem( 'devicePlatform' )
	};

	$.ajax({
		type: 'POST',
		url: getServer() +'v1-4/updateCode.php',
		data: formData,
		dataType: 'json',
		encode: true
	})
	.done(function(dataUpdate) {
		//alert('done');
		//console.log("CodeDone = " + dataUpdate.reload);
		if (dataUpdate.reload === true) {
			refreshing();
		}
	})
	.fail(function(dataUpdate) {
		//console.log("CodeFail = " + dataUpdate.reload);
		//alert('fail');
	});

}

function successHandler(result) {
}

function errorHandler(error) {
}